VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ComputerInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Notice these API declarations are private - we don't want them accessed directly
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" _
                         (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function SetComputerName Lib "kernel32" Alias "SetComputerNameA" _
                         (ByVal lpComputerName As String) As Long

Public Event RebootNeeded()

Public Property Get ComputerName() As String
    Dim sName As String
    Dim lRetVal As Long
    Dim iPos As Integer

    'API's generally require fixed-length strings, which means
    'pre-filling them with spaces, nulls, or Dim sName As String * 255
    sName = Space$(255)

    'Actually call the API
    lRetVal = GetComputerName(sName, 255&)

    'If the API returns 0 then it didn't work, so exit
    If lRetVal = 0 Then Exit Property

    'GetComputerName puts a null character, Chr$(0), on the end of the
    'string, so we need to remove it before returning the computer name.
    iPos = InStr(sName, Chr$(0))
    ComputerName = Left$(sName, iPos - 1)

End Property

Public Property Let ComputerName(ByVal sNewName As String)

    Dim lRetVal As Long
    lRetVal = SetComputerName(sNewName)
    RaiseEvent RebootNeeded

End Property


