Attribute VB_Name = "Module1"
Option Explicit
Dim sINIfile As String
Dim nCount As Integer
Dim sTemp As String
Dim nTemp As Integer
Global nDisp As Integer
Sub ClearList()
    If nCount = 0 Then Exit Sub
    nTemp = MsgBox("Clear All Entries?", vbYesNo + vbQuestion, "Clear Call List")
    If nTemp <> vbYes Then Exit Sub
    nCount = 0
    writeINIString sINIfile, "General", "CallCount", CStr(nCount)
    ClearStuff
End Sub


Sub ClearStuff()
    With frmMain
        .lbldbName = "Waiting for call . . . "
        .lblName = ""
        .lblNumber = ""
        .lblTime = ""
        .lblCount = "0 / 0"
    End With
End Sub


Sub DisplayList(nIndex As Integer)
    Dim sSection As String
    Dim sName As String
    sSection = "Call" & nIndex
    
    If nIndex <= 0 Or nIndex > nCount Then
        ClearStuff
        Exit Sub
    End If
    
    With frmMain
        sName = sGetINIString(sINIfile, sSection, "Name", "Unknown")
        .lblName = sName
        .lbldbName = sGetINIString(sINIfile, "XRef", sName, sName)
        .lblNumber = "Number: " & sGetINIString(sINIfile, sSection, "Number", "?")
        .lblTime = "Time: " & sGetINIString(sINIfile, sSection, "Time", "")
        .Caption = "Callid - " & sName
        .lblCount = nIndex & " / " & nCount
    End With
    
    nDisp = nIndex

End Sub



Sub CheckForCall()
    Dim nPrevCount As Integer
    Dim l As Long
    Dim sFile As String
    
    With frmMain
        If .MSComm1.InBufferCount >= 2 Then
            
            'STOP TIMER AND GET INPUT FROM COM PORT
            .tmrMain.Enabled = False
            sTemp = .MSComm1.Input
            
            'If input is a small string then ignore, it
            'might just be the first 'RING' signal
            If Len(sTemp) < 10 Then
                .tmrMain.Enabled = True
                Exit Sub
            End If
        
            'STORE CALL COUNTER, ADD INFO TO INI FILE
            nPrevCount = nCount
            WriteCIDData (sTemp)
        
            'IF NO DATA WAS FOUND THEN EXIT
            If nCount = nPrevCount Then
                ClearStuff
                .lbldbName = "No Data Sent " & Now
                Exit Sub
            End If
    
            'DISPLAY CALLER INFORMATION ON THE FORM,
            'PLAY THE SOUND FILE A COUPLE OF TIMES
            DisplayList nCount
        
            sTemp = sGetINIString(sINIfile, "Call" & nCount, "Name", "Unknown")
            sFile = sGetINIString(sINIfile, "Sounds", sTemp, "?")
            If sFile <> "?" Then
                l = sndPlaySound(sFile, SND_SYNC)
                l = sndPlaySound(sFile, SND_ASYNC)
            End If
        End If
        
        'CLEAR ANY EXTRA INPUT FROM THE COMM CONTROL
        sTemp = .MSComm1.Input
        
        'RESTART TIMER FOR NEXT CALL
        .tmrMain.Enabled = True
        
    End With

End Sub






Sub EndProgram()
    frmMain.MSComm1.PortOpen = False
    End
End Sub


Sub Main()
    Dim nComPort As Integer
    Dim sInit As String
    Dim sTemp As String
    Dim bStop As Boolean
    
    sINIfile = App.Path & "\CALLID.INI"
    nComPort = CInt(sGetINIString(sINIfile, "General", "ComPort", "2"))
    sInit = sGetINIString(sINIfile, "General", "InitString", "AT#CID=1")
    
    With frmMain
        'SET UP THE COM PORT
        .MSComm1.CommPort = nComPort
        .MSComm1.Settings = "9600,N,8,1"
        .MSComm1.InputLen = 0
        
        'OPEN THE CONNECTION AND SEND THE INIT STRING
        .MSComm1.PortOpen = True
        .MSComm1.Output = sInit + Chr$(13)
        
        'WAIT A FEW SECONDS FOR MODEM RESPONSE
        nTemp = 0
        bStop = False
        While nTemp < 32000 And bStop = False
            nTemp = nTemp + 1
            If .MSComm1.InBufferCount >= 2 Then
                sTemp = .MSComm1.Input
                If InStr(sTemp, sInit) = 0 Then bStop = True
            End If
        Wend
    
        'IF THE MODEM DIDN'T SAY OK THEN END
        If InStr(sTemp, "OK") = 0 Then
            MsgBox "Modem did not respond with OK.", vbOK + vbCritical, "Initialize Error"
            End
        End If
        DoEvents
        
        'CLEAR REMAINING INPUT
        sTemp = .MSComm1.Input
        
        'START THE POLLING TIMER
        .tmrMain.Enabled = True
            
    End With
    
    'DISPLAY CALLER INFORMATION FROM LAST TIME
    nCount = CInt(sGetINIString(sINIfile, "General", "CallCount", "0"))
    DisplayList nCount
    frmMain.Show

End Sub


Sub WriteCIDData(sInput As String)
    Dim sName As String
    Dim sNumber As String
    Dim sTime As String
    Dim sDate As String
    Dim sSection As String
   
    'PARSE EACH PIECE OF INFORMATION FROM THE INPUT STRING
    'THIS WILL VARY FROM MODEM TO MODEM (MINE IS A CARDINAL 33.6)
   
    sNumber = "?"
   
    If InStr(sInput, "MESG =") Then
        nTemp = InStr(sInput, "MESG =")
        sName = Mid(sInput, nTemp + 7)
        sNumber = "NO NUMBER SENT"
    Else
        nTemp = InStr(sInput, "NMBR =")
        If nTemp <> 0 Then sNumber = Mid(sInput, nTemp + 7, 10)
        
        nTemp = InStr(sInput, "NAME =")
        If nTemp <> 0 Then sName = Mid(sInput, nTemp + 7)

        nTemp = InStr(sInput, "DATE =")
        If nTemp <> 0 Then sDate = Mid(sInput, nTemp + 7, 4)

        nTemp = InStr(sInput, "TIME =")
        If nTemp <> 0 Then sTime = Mid(sInput, nTemp + 7, 4)
    
        sTemp = Left$(sNumber, 3) & "-" & Mid$(sNumber, 4, 3) & "-" & Right$(sNumber, 4)
        sNumber = sTemp
    End If
    
    If sNumber = "?" Then Exit Sub
    
    'WRITE INFORMATION TO THE INI FILE
    
    nCount = nCount + 1
    writeINIString sINIfile, "General", "CallCount", CStr(nCount)
    
    sSection = "Call" & nCount
    writeINIString sINIfile, sSection, "Time", Format$(Now, "mm/dd hh:mm a/p")
    writeINIString sINIfile, sSection, "Number", sNumber
    writeINIString sINIfile, sSection, "Name", sName

End Sub





